# coding: utf-8

"""
    Sonatype Nexus IQ Server

    This documents the available APIs into [Sonatype Nexus IQ Server](https://www.sonatype.com/products/open-source-security-dependency-management) (also knwon as Nexus Lifecycle).   # noqa: E501

    OpenAPI spec version: 156
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from nexus_iq_sdk.api_client import ApiClient


class ConfigArtifactoryConnectionApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def add_artifactory_connection(
        self, owner_type, internal_owner_id, **kwargs
    ):  # noqa: E501
        """add_artifactory_connection  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.add_artifactory_connection(owner_type, internal_owner_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str owner_type: (required)
        :param str internal_owner_id: (required)
        :param ApiArtifactoryConnectionDTO body:
        :return: ApiArtifactoryConnectionDTO
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs["_return_http_data_only"] = True
        if kwargs.get("async_req"):
            return self.add_artifactory_connection_with_http_info(
                owner_type, internal_owner_id, **kwargs
            )  # noqa: E501
        else:
            (data) = self.add_artifactory_connection_with_http_info(
                owner_type, internal_owner_id, **kwargs
            )  # noqa: E501
            return data

    def add_artifactory_connection_with_http_info(
        self, owner_type, internal_owner_id, **kwargs
    ):  # noqa: E501
        """add_artifactory_connection  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.add_artifactory_connection_with_http_info(owner_type, internal_owner_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str owner_type: (required)
        :param str internal_owner_id: (required)
        :param ApiArtifactoryConnectionDTO body:
        :return: ApiArtifactoryConnectionDTO
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ["owner_type", "internal_owner_id", "body"]  # noqa: E501
        all_params.append("async_req")
        all_params.append("_return_http_data_only")
        all_params.append("_preload_content")
        all_params.append("_request_timeout")

        params = locals()
        for key, val in six.iteritems(params["kwargs"]):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method add_artifactory_connection" % key
                )
            params[key] = val
        del params["kwargs"]
        # verify the required parameter 'owner_type' is set
        if "owner_type" not in params or params["owner_type"] is None:
            raise ValueError(
                "Missing the required parameter `owner_type` when calling `add_artifactory_connection`"
            )  # noqa: E501
        # verify the required parameter 'internal_owner_id' is set
        if "internal_owner_id" not in params or params["internal_owner_id"] is None:
            raise ValueError(
                "Missing the required parameter `internal_owner_id` when calling `add_artifactory_connection`"
            )  # noqa: E501

        collection_formats = {}

        path_params = {}
        if "owner_type" in params:
            path_params["ownerType"] = params["owner_type"]  # noqa: E501
        if "internal_owner_id" in params:
            path_params["internalOwnerId"] = params["internal_owner_id"]  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if "body" in params:
            body_params = params["body"]
        # HTTP header `Accept`
        header_params["Accept"] = self.api_client.select_header_accept(
            ["application/json"]
        )  # noqa: E501

        # HTTP header `Content-Type`
        header_params[
            "Content-Type"
        ] = self.api_client.select_header_content_type(  # noqa: E501
            ["application/json"]
        )  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            "/api/v2/config/artifactoryConnection/{ownerType}/{internalOwnerId}",
            "POST",
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type="ApiArtifactoryConnectionDTO",  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get("async_req"),
            _return_http_data_only=params.get("_return_http_data_only"),
            _preload_content=params.get("_preload_content", True),
            _request_timeout=params.get("_request_timeout"),
            collection_formats=collection_formats,
        )

    def delete_artifactory_connection(
        self, owner_type, internal_owner_id, artifactory_connection_id, **kwargs
    ):  # noqa: E501
        """delete_artifactory_connection  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.delete_artifactory_connection(owner_type, internal_owner_id, artifactory_connection_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str owner_type: (required)
        :param str internal_owner_id: (required)
        :param str artifactory_connection_id: (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs["_return_http_data_only"] = True
        if kwargs.get("async_req"):
            return self.delete_artifactory_connection_with_http_info(
                owner_type, internal_owner_id, artifactory_connection_id, **kwargs
            )  # noqa: E501
        else:
            (data) = self.delete_artifactory_connection_with_http_info(
                owner_type, internal_owner_id, artifactory_connection_id, **kwargs
            )  # noqa: E501
            return data

    def delete_artifactory_connection_with_http_info(
        self, owner_type, internal_owner_id, artifactory_connection_id, **kwargs
    ):  # noqa: E501
        """delete_artifactory_connection  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.delete_artifactory_connection_with_http_info(owner_type, internal_owner_id, artifactory_connection_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str owner_type: (required)
        :param str internal_owner_id: (required)
        :param str artifactory_connection_id: (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = [
            "owner_type",
            "internal_owner_id",
            "artifactory_connection_id",
        ]  # noqa: E501
        all_params.append("async_req")
        all_params.append("_return_http_data_only")
        all_params.append("_preload_content")
        all_params.append("_request_timeout")

        params = locals()
        for key, val in six.iteritems(params["kwargs"]):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method delete_artifactory_connection" % key
                )
            params[key] = val
        del params["kwargs"]
        # verify the required parameter 'owner_type' is set
        if "owner_type" not in params or params["owner_type"] is None:
            raise ValueError(
                "Missing the required parameter `owner_type` when calling `delete_artifactory_connection`"
            )  # noqa: E501
        # verify the required parameter 'internal_owner_id' is set
        if "internal_owner_id" not in params or params["internal_owner_id"] is None:
            raise ValueError(
                "Missing the required parameter `internal_owner_id` when calling `delete_artifactory_connection`"
            )  # noqa: E501
        # verify the required parameter 'artifactory_connection_id' is set
        if (
            "artifactory_connection_id" not in params
            or params["artifactory_connection_id"] is None
        ):
            raise ValueError(
                "Missing the required parameter `artifactory_connection_id` when calling `delete_artifactory_connection`"
            )  # noqa: E501

        collection_formats = {}

        path_params = {}
        if "owner_type" in params:
            path_params["ownerType"] = params["owner_type"]  # noqa: E501
        if "internal_owner_id" in params:
            path_params["internalOwnerId"] = params["internal_owner_id"]  # noqa: E501
        if "artifactory_connection_id" in params:
            path_params["artifactoryConnectionId"] = params[
                "artifactory_connection_id"
            ]  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params["Accept"] = self.api_client.select_header_accept(
            ["*/*"]
        )  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            "/api/v2/config/artifactoryConnection/{ownerType}/{internalOwnerId}/{artifactoryConnectionId}",
            "DELETE",
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get("async_req"),
            _return_http_data_only=params.get("_return_http_data_only"),
            _preload_content=params.get("_preload_content", True),
            _request_timeout=params.get("_request_timeout"),
            collection_formats=collection_formats,
        )

    def get_artifactory_connection(
        self, owner_type, internal_owner_id, artifactory_connection_id, **kwargs
    ):  # noqa: E501
        """get_artifactory_connection  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_artifactory_connection(owner_type, internal_owner_id, artifactory_connection_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str owner_type: (required)
        :param str internal_owner_id: (required)
        :param str artifactory_connection_id: (required)
        :return: ApiArtifactoryConnectionDTO
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs["_return_http_data_only"] = True
        if kwargs.get("async_req"):
            return self.get_artifactory_connection_with_http_info(
                owner_type, internal_owner_id, artifactory_connection_id, **kwargs
            )  # noqa: E501
        else:
            (data) = self.get_artifactory_connection_with_http_info(
                owner_type, internal_owner_id, artifactory_connection_id, **kwargs
            )  # noqa: E501
            return data

    def get_artifactory_connection_with_http_info(
        self, owner_type, internal_owner_id, artifactory_connection_id, **kwargs
    ):  # noqa: E501
        """get_artifactory_connection  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_artifactory_connection_with_http_info(owner_type, internal_owner_id, artifactory_connection_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str owner_type: (required)
        :param str internal_owner_id: (required)
        :param str artifactory_connection_id: (required)
        :return: ApiArtifactoryConnectionDTO
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = [
            "owner_type",
            "internal_owner_id",
            "artifactory_connection_id",
        ]  # noqa: E501
        all_params.append("async_req")
        all_params.append("_return_http_data_only")
        all_params.append("_preload_content")
        all_params.append("_request_timeout")

        params = locals()
        for key, val in six.iteritems(params["kwargs"]):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_artifactory_connection" % key
                )
            params[key] = val
        del params["kwargs"]
        # verify the required parameter 'owner_type' is set
        if "owner_type" not in params or params["owner_type"] is None:
            raise ValueError(
                "Missing the required parameter `owner_type` when calling `get_artifactory_connection`"
            )  # noqa: E501
        # verify the required parameter 'internal_owner_id' is set
        if "internal_owner_id" not in params or params["internal_owner_id"] is None:
            raise ValueError(
                "Missing the required parameter `internal_owner_id` when calling `get_artifactory_connection`"
            )  # noqa: E501
        # verify the required parameter 'artifactory_connection_id' is set
        if (
            "artifactory_connection_id" not in params
            or params["artifactory_connection_id"] is None
        ):
            raise ValueError(
                "Missing the required parameter `artifactory_connection_id` when calling `get_artifactory_connection`"
            )  # noqa: E501

        collection_formats = {}

        path_params = {}
        if "owner_type" in params:
            path_params["ownerType"] = params["owner_type"]  # noqa: E501
        if "internal_owner_id" in params:
            path_params["internalOwnerId"] = params["internal_owner_id"]  # noqa: E501
        if "artifactory_connection_id" in params:
            path_params["artifactoryConnectionId"] = params[
                "artifactory_connection_id"
            ]  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params["Accept"] = self.api_client.select_header_accept(
            ["application/json"]
        )  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            "/api/v2/config/artifactoryConnection/{ownerType}/{internalOwnerId}/{artifactoryConnectionId}",
            "GET",
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type="ApiArtifactoryConnectionDTO",  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get("async_req"),
            _return_http_data_only=params.get("_return_http_data_only"),
            _preload_content=params.get("_preload_content", True),
            _request_timeout=params.get("_request_timeout"),
            collection_formats=collection_formats,
        )

    def get_owner_artifactory_connection(
        self, owner_type, internal_owner_id, **kwargs
    ):  # noqa: E501
        """get_owner_artifactory_connection  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_owner_artifactory_connection(owner_type, internal_owner_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str owner_type: (required)
        :param str internal_owner_id: (required)
        :param bool inherit:
        :return: ApiOwnerArtifactoryConnectionDTO
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs["_return_http_data_only"] = True
        if kwargs.get("async_req"):
            return self.get_owner_artifactory_connection_with_http_info(
                owner_type, internal_owner_id, **kwargs
            )  # noqa: E501
        else:
            (data) = self.get_owner_artifactory_connection_with_http_info(
                owner_type, internal_owner_id, **kwargs
            )  # noqa: E501
            return data

    def get_owner_artifactory_connection_with_http_info(
        self, owner_type, internal_owner_id, **kwargs
    ):  # noqa: E501
        """get_owner_artifactory_connection  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_owner_artifactory_connection_with_http_info(owner_type, internal_owner_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str owner_type: (required)
        :param str internal_owner_id: (required)
        :param bool inherit:
        :return: ApiOwnerArtifactoryConnectionDTO
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ["owner_type", "internal_owner_id", "inherit"]  # noqa: E501
        all_params.append("async_req")
        all_params.append("_return_http_data_only")
        all_params.append("_preload_content")
        all_params.append("_request_timeout")

        params = locals()
        for key, val in six.iteritems(params["kwargs"]):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_owner_artifactory_connection" % key
                )
            params[key] = val
        del params["kwargs"]
        # verify the required parameter 'owner_type' is set
        if "owner_type" not in params or params["owner_type"] is None:
            raise ValueError(
                "Missing the required parameter `owner_type` when calling `get_owner_artifactory_connection`"
            )  # noqa: E501
        # verify the required parameter 'internal_owner_id' is set
        if "internal_owner_id" not in params or params["internal_owner_id"] is None:
            raise ValueError(
                "Missing the required parameter `internal_owner_id` when calling `get_owner_artifactory_connection`"
            )  # noqa: E501

        collection_formats = {}

        path_params = {}
        if "owner_type" in params:
            path_params["ownerType"] = params["owner_type"]  # noqa: E501
        if "internal_owner_id" in params:
            path_params["internalOwnerId"] = params["internal_owner_id"]  # noqa: E501

        query_params = []
        if "inherit" in params:
            query_params.append(("inherit", params["inherit"]))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params["Accept"] = self.api_client.select_header_accept(
            ["application/json"]
        )  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            "/api/v2/config/artifactoryConnection/{ownerType}/{internalOwnerId}",
            "GET",
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type="ApiOwnerArtifactoryConnectionDTO",  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get("async_req"),
            _return_http_data_only=params.get("_return_http_data_only"),
            _preload_content=params.get("_preload_content", True),
            _request_timeout=params.get("_request_timeout"),
            collection_formats=collection_formats,
        )

    def test_artifactory_connection(
        self, owner_type, internal_owner_id, **kwargs
    ):  # noqa: E501
        """test_artifactory_connection  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.test_artifactory_connection(owner_type, internal_owner_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str owner_type: (required)
        :param str internal_owner_id: (required)
        :param ApiArtifactoryConnectionDTO body:
        :return: ApiStatusDTO
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs["_return_http_data_only"] = True
        if kwargs.get("async_req"):
            return self.test_artifactory_connection_with_http_info(
                owner_type, internal_owner_id, **kwargs
            )  # noqa: E501
        else:
            (data) = self.test_artifactory_connection_with_http_info(
                owner_type, internal_owner_id, **kwargs
            )  # noqa: E501
            return data

    def test_artifactory_connection_with_http_info(
        self, owner_type, internal_owner_id, **kwargs
    ):  # noqa: E501
        """test_artifactory_connection  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.test_artifactory_connection_with_http_info(owner_type, internal_owner_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str owner_type: (required)
        :param str internal_owner_id: (required)
        :param ApiArtifactoryConnectionDTO body:
        :return: ApiStatusDTO
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ["owner_type", "internal_owner_id", "body"]  # noqa: E501
        all_params.append("async_req")
        all_params.append("_return_http_data_only")
        all_params.append("_preload_content")
        all_params.append("_request_timeout")

        params = locals()
        for key, val in six.iteritems(params["kwargs"]):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method test_artifactory_connection" % key
                )
            params[key] = val
        del params["kwargs"]
        # verify the required parameter 'owner_type' is set
        if "owner_type" not in params or params["owner_type"] is None:
            raise ValueError(
                "Missing the required parameter `owner_type` when calling `test_artifactory_connection`"
            )  # noqa: E501
        # verify the required parameter 'internal_owner_id' is set
        if "internal_owner_id" not in params or params["internal_owner_id"] is None:
            raise ValueError(
                "Missing the required parameter `internal_owner_id` when calling `test_artifactory_connection`"
            )  # noqa: E501

        collection_formats = {}

        path_params = {}
        if "owner_type" in params:
            path_params["ownerType"] = params["owner_type"]  # noqa: E501
        if "internal_owner_id" in params:
            path_params["internalOwnerId"] = params["internal_owner_id"]  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if "body" in params:
            body_params = params["body"]
        # HTTP header `Accept`
        header_params["Accept"] = self.api_client.select_header_accept(
            ["application/json"]
        )  # noqa: E501

        # HTTP header `Content-Type`
        header_params[
            "Content-Type"
        ] = self.api_client.select_header_content_type(  # noqa: E501
            ["*/*"]
        )  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            "/api/v2/config/artifactoryConnection/{ownerType}/{internalOwnerId}/test",
            "POST",
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type="ApiStatusDTO",  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get("async_req"),
            _return_http_data_only=params.get("_return_http_data_only"),
            _preload_content=params.get("_preload_content", True),
            _request_timeout=params.get("_request_timeout"),
            collection_formats=collection_formats,
        )

    def test_artifactory_connection1(
        self, owner_type, internal_owner_id, artifactory_connection_id, **kwargs
    ):  # noqa: E501
        """test_artifactory_connection1  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.test_artifactory_connection1(owner_type, internal_owner_id, artifactory_connection_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str owner_type: (required)
        :param str internal_owner_id: (required)
        :param str artifactory_connection_id: (required)
        :return: ApiStatusDTO
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs["_return_http_data_only"] = True
        if kwargs.get("async_req"):
            return self.test_artifactory_connection1_with_http_info(
                owner_type, internal_owner_id, artifactory_connection_id, **kwargs
            )  # noqa: E501
        else:
            (data) = self.test_artifactory_connection1_with_http_info(
                owner_type, internal_owner_id, artifactory_connection_id, **kwargs
            )  # noqa: E501
            return data

    def test_artifactory_connection1_with_http_info(
        self, owner_type, internal_owner_id, artifactory_connection_id, **kwargs
    ):  # noqa: E501
        """test_artifactory_connection1  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.test_artifactory_connection1_with_http_info(owner_type, internal_owner_id, artifactory_connection_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str owner_type: (required)
        :param str internal_owner_id: (required)
        :param str artifactory_connection_id: (required)
        :return: ApiStatusDTO
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = [
            "owner_type",
            "internal_owner_id",
            "artifactory_connection_id",
        ]  # noqa: E501
        all_params.append("async_req")
        all_params.append("_return_http_data_only")
        all_params.append("_preload_content")
        all_params.append("_request_timeout")

        params = locals()
        for key, val in six.iteritems(params["kwargs"]):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method test_artifactory_connection1" % key
                )
            params[key] = val
        del params["kwargs"]
        # verify the required parameter 'owner_type' is set
        if "owner_type" not in params or params["owner_type"] is None:
            raise ValueError(
                "Missing the required parameter `owner_type` when calling `test_artifactory_connection1`"
            )  # noqa: E501
        # verify the required parameter 'internal_owner_id' is set
        if "internal_owner_id" not in params or params["internal_owner_id"] is None:
            raise ValueError(
                "Missing the required parameter `internal_owner_id` when calling `test_artifactory_connection1`"
            )  # noqa: E501
        # verify the required parameter 'artifactory_connection_id' is set
        if (
            "artifactory_connection_id" not in params
            or params["artifactory_connection_id"] is None
        ):
            raise ValueError(
                "Missing the required parameter `artifactory_connection_id` when calling `test_artifactory_connection1`"
            )  # noqa: E501

        collection_formats = {}

        path_params = {}
        if "owner_type" in params:
            path_params["ownerType"] = params["owner_type"]  # noqa: E501
        if "internal_owner_id" in params:
            path_params["internalOwnerId"] = params["internal_owner_id"]  # noqa: E501
        if "artifactory_connection_id" in params:
            path_params["artifactoryConnectionId"] = params[
                "artifactory_connection_id"
            ]  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params["Accept"] = self.api_client.select_header_accept(
            ["application/json"]
        )  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            "/api/v2/config/artifactoryConnection/{ownerType}/{internalOwnerId}/{artifactoryConnectionId}/test",
            "POST",
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type="ApiStatusDTO",  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get("async_req"),
            _return_http_data_only=params.get("_return_http_data_only"),
            _preload_content=params.get("_preload_content", True),
            _request_timeout=params.get("_request_timeout"),
            collection_formats=collection_formats,
        )

    def update_artifactory_connection(
        self, owner_type, internal_owner_id, artifactory_connection_id, **kwargs
    ):  # noqa: E501
        """update_artifactory_connection  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.update_artifactory_connection(owner_type, internal_owner_id, artifactory_connection_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str owner_type: (required)
        :param str internal_owner_id: (required)
        :param str artifactory_connection_id: (required)
        :param ApiArtifactoryConnectionDTO body:
        :return: ApiArtifactoryConnectionDTO
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs["_return_http_data_only"] = True
        if kwargs.get("async_req"):
            return self.update_artifactory_connection_with_http_info(
                owner_type, internal_owner_id, artifactory_connection_id, **kwargs
            )  # noqa: E501
        else:
            (data) = self.update_artifactory_connection_with_http_info(
                owner_type, internal_owner_id, artifactory_connection_id, **kwargs
            )  # noqa: E501
            return data

    def update_artifactory_connection_with_http_info(
        self, owner_type, internal_owner_id, artifactory_connection_id, **kwargs
    ):  # noqa: E501
        """update_artifactory_connection  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.update_artifactory_connection_with_http_info(owner_type, internal_owner_id, artifactory_connection_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str owner_type: (required)
        :param str internal_owner_id: (required)
        :param str artifactory_connection_id: (required)
        :param ApiArtifactoryConnectionDTO body:
        :return: ApiArtifactoryConnectionDTO
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = [
            "owner_type",
            "internal_owner_id",
            "artifactory_connection_id",
            "body",
        ]  # noqa: E501
        all_params.append("async_req")
        all_params.append("_return_http_data_only")
        all_params.append("_preload_content")
        all_params.append("_request_timeout")

        params = locals()
        for key, val in six.iteritems(params["kwargs"]):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method update_artifactory_connection" % key
                )
            params[key] = val
        del params["kwargs"]
        # verify the required parameter 'owner_type' is set
        if "owner_type" not in params or params["owner_type"] is None:
            raise ValueError(
                "Missing the required parameter `owner_type` when calling `update_artifactory_connection`"
            )  # noqa: E501
        # verify the required parameter 'internal_owner_id' is set
        if "internal_owner_id" not in params or params["internal_owner_id"] is None:
            raise ValueError(
                "Missing the required parameter `internal_owner_id` when calling `update_artifactory_connection`"
            )  # noqa: E501
        # verify the required parameter 'artifactory_connection_id' is set
        if (
            "artifactory_connection_id" not in params
            or params["artifactory_connection_id"] is None
        ):
            raise ValueError(
                "Missing the required parameter `artifactory_connection_id` when calling `update_artifactory_connection`"
            )  # noqa: E501

        collection_formats = {}

        path_params = {}
        if "owner_type" in params:
            path_params["ownerType"] = params["owner_type"]  # noqa: E501
        if "internal_owner_id" in params:
            path_params["internalOwnerId"] = params["internal_owner_id"]  # noqa: E501
        if "artifactory_connection_id" in params:
            path_params["artifactoryConnectionId"] = params[
                "artifactory_connection_id"
            ]  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if "body" in params:
            body_params = params["body"]
        # HTTP header `Accept`
        header_params["Accept"] = self.api_client.select_header_accept(
            ["application/json"]
        )  # noqa: E501

        # HTTP header `Content-Type`
        header_params[
            "Content-Type"
        ] = self.api_client.select_header_content_type(  # noqa: E501
            ["application/json"]
        )  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            "/api/v2/config/artifactoryConnection/{ownerType}/{internalOwnerId}/{artifactoryConnectionId}",
            "PUT",
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type="ApiArtifactoryConnectionDTO",  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get("async_req"),
            _return_http_data_only=params.get("_return_http_data_only"),
            _preload_content=params.get("_preload_content", True),
            _request_timeout=params.get("_request_timeout"),
            collection_formats=collection_formats,
        )

    def update_owner_artifactory_connection_status(
        self, owner_type, internal_owner_id, **kwargs
    ):  # noqa: E501
        """update_owner_artifactory_connection_status  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.update_owner_artifactory_connection_status(owner_type, internal_owner_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str owner_type: (required)
        :param str internal_owner_id: (required)
        :param ApiArtifactoryConnectionStatusRequestDTO body:
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs["_return_http_data_only"] = True
        if kwargs.get("async_req"):
            return self.update_owner_artifactory_connection_status_with_http_info(
                owner_type, internal_owner_id, **kwargs
            )  # noqa: E501
        else:
            (data) = self.update_owner_artifactory_connection_status_with_http_info(
                owner_type, internal_owner_id, **kwargs
            )  # noqa: E501
            return data

    def update_owner_artifactory_connection_status_with_http_info(
        self, owner_type, internal_owner_id, **kwargs
    ):  # noqa: E501
        """update_owner_artifactory_connection_status  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.update_owner_artifactory_connection_status_with_http_info(owner_type, internal_owner_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str owner_type: (required)
        :param str internal_owner_id: (required)
        :param ApiArtifactoryConnectionStatusRequestDTO body:
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ["owner_type", "internal_owner_id", "body"]  # noqa: E501
        all_params.append("async_req")
        all_params.append("_return_http_data_only")
        all_params.append("_preload_content")
        all_params.append("_request_timeout")

        params = locals()
        for key, val in six.iteritems(params["kwargs"]):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method update_owner_artifactory_connection_status" % key
                )
            params[key] = val
        del params["kwargs"]
        # verify the required parameter 'owner_type' is set
        if "owner_type" not in params or params["owner_type"] is None:
            raise ValueError(
                "Missing the required parameter `owner_type` when calling `update_owner_artifactory_connection_status`"
            )  # noqa: E501
        # verify the required parameter 'internal_owner_id' is set
        if "internal_owner_id" not in params or params["internal_owner_id"] is None:
            raise ValueError(
                "Missing the required parameter `internal_owner_id` when calling `update_owner_artifactory_connection_status`"
            )  # noqa: E501

        collection_formats = {}

        path_params = {}
        if "owner_type" in params:
            path_params["ownerType"] = params["owner_type"]  # noqa: E501
        if "internal_owner_id" in params:
            path_params["internalOwnerId"] = params["internal_owner_id"]  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if "body" in params:
            body_params = params["body"]
        # HTTP header `Accept`
        header_params["Accept"] = self.api_client.select_header_accept(
            ["application/json"]
        )  # noqa: E501

        # HTTP header `Content-Type`
        header_params[
            "Content-Type"
        ] = self.api_client.select_header_content_type(  # noqa: E501
            ["application/json"]
        )  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            "/api/v2/config/artifactoryConnection/{ownerType}/{internalOwnerId}",
            "PUT",
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get("async_req"),
            _return_http_data_only=params.get("_return_http_data_only"),
            _preload_content=params.get("_preload_content", True),
            _request_timeout=params.get("_request_timeout"),
            collection_formats=collection_formats,
        )
