# coding: utf-8

"""
    Sonatype Nexus IQ Server

    This documents the available APIs into [Sonatype Nexus IQ Server](https://www.sonatype.com/products/open-source-security-dependency-management) (also knwon as Nexus Lifecycle).   # noqa: E501

    OpenAPI spec version: 156
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from nexus_iq_sdk.api_client import ApiClient


class ScanApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def get_scan_status(self, application_id, scan_request_id, **kwargs):  # noqa: E501
        """get_scan_status  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_scan_status(application_id, scan_request_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str application_id: (required)
        :param str scan_request_id: (required)
        :return: ApiThirdPartyScanResultDTO
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs["_return_http_data_only"] = True
        if kwargs.get("async_req"):
            return self.get_scan_status_with_http_info(
                application_id, scan_request_id, **kwargs
            )  # noqa: E501
        else:
            (data) = self.get_scan_status_with_http_info(
                application_id, scan_request_id, **kwargs
            )  # noqa: E501
            return data

    def get_scan_status_with_http_info(
        self, application_id, scan_request_id, **kwargs
    ):  # noqa: E501
        """get_scan_status  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_scan_status_with_http_info(application_id, scan_request_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str application_id: (required)
        :param str scan_request_id: (required)
        :return: ApiThirdPartyScanResultDTO
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ["application_id", "scan_request_id"]  # noqa: E501
        all_params.append("async_req")
        all_params.append("_return_http_data_only")
        all_params.append("_preload_content")
        all_params.append("_request_timeout")

        params = locals()
        for key, val in six.iteritems(params["kwargs"]):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_scan_status" % key
                )
            params[key] = val
        del params["kwargs"]
        # verify the required parameter 'application_id' is set
        if "application_id" not in params or params["application_id"] is None:
            raise ValueError(
                "Missing the required parameter `application_id` when calling `get_scan_status`"
            )  # noqa: E501
        # verify the required parameter 'scan_request_id' is set
        if "scan_request_id" not in params or params["scan_request_id"] is None:
            raise ValueError(
                "Missing the required parameter `scan_request_id` when calling `get_scan_status`"
            )  # noqa: E501

        collection_formats = {}

        path_params = {}
        if "application_id" in params:
            path_params["applicationId"] = params["application_id"]  # noqa: E501
        if "scan_request_id" in params:
            path_params["scanRequestId"] = params["scan_request_id"]  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params["Accept"] = self.api_client.select_header_accept(
            ["application/json"]
        )  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            "/api/v2/scan/applications/{applicationId}/status/{scanRequestId}",
            "GET",
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type="ApiThirdPartyScanResultDTO",  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get("async_req"),
            _return_http_data_only=params.get("_return_http_data_only"),
            _preload_content=params.get("_preload_content", True),
            _request_timeout=params.get("_request_timeout"),
            collection_formats=collection_formats,
        )

    def scan_components(self, application_id, source, **kwargs):  # noqa: E501
        """scan_components  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.scan_components(application_id, source, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str application_id: (required)
        :param str source: (required)
        :param str body:
        :param str stage_id:
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs["_return_http_data_only"] = True
        if kwargs.get("async_req"):
            return self.scan_components_with_http_info(
                application_id, source, **kwargs
            )  # noqa: E501
        else:
            (data) = self.scan_components_with_http_info(
                application_id, source, **kwargs
            )  # noqa: E501
            return data

    def scan_components_with_http_info(
        self, application_id, source, **kwargs
    ):  # noqa: E501
        """scan_components  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.scan_components_with_http_info(application_id, source, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str application_id: (required)
        :param str source: (required)
        :param str body:
        :param str stage_id:
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ["application_id", "source", "body", "stage_id"]  # noqa: E501
        all_params.append("async_req")
        all_params.append("_return_http_data_only")
        all_params.append("_preload_content")
        all_params.append("_request_timeout")

        params = locals()
        for key, val in six.iteritems(params["kwargs"]):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method scan_components" % key
                )
            params[key] = val
        del params["kwargs"]
        # verify the required parameter 'application_id' is set
        if "application_id" not in params or params["application_id"] is None:
            raise ValueError(
                "Missing the required parameter `application_id` when calling `scan_components`"
            )  # noqa: E501
        # verify the required parameter 'source' is set
        if "source" not in params or params["source"] is None:
            raise ValueError(
                "Missing the required parameter `source` when calling `scan_components`"
            )  # noqa: E501

        collection_formats = {}

        path_params = {}
        if "application_id" in params:
            path_params["applicationId"] = params["application_id"]  # noqa: E501
        if "source" in params:
            path_params["source"] = params["source"]  # noqa: E501

        query_params = []
        if "stage_id" in params:
            query_params.append(("stageId", params["stage_id"]))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if "body" in params:
            body_params = params["body"]
        # HTTP header `Accept`
        header_params["Accept"] = self.api_client.select_header_accept(
            ["application/json"]
        )  # noqa: E501

        # HTTP header `Content-Type`
        header_params[
            "Content-Type"
        ] = self.api_client.select_header_content_type(  # noqa: E501
            ["application/xml", "application/json"]
        )  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            "/api/v2/scan/applications/{applicationId}/sources/{source}",
            "POST",
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get("async_req"),
            _return_http_data_only=params.get("_return_http_data_only"),
            _preload_content=params.get("_preload_content", True),
            _request_timeout=params.get("_request_timeout"),
            collection_formats=collection_formats,
        )
